#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
	ofBackground(255,255,255);
	ofSetVerticalSync(true);
	frameByframe = false;

	// Uncomment this to show movies with alpha channels
	// testMovie.setPixelFormat(OF_PIXELS_RGBA);
	testMovie.setPixelFormat(OF_PIXELS_NATIVE);

	testMovie.load("movies/Timecoded_Big_bunny_2.mov");
	testMovie.setLoopState(OF_LOOP_NORMAL);
	testMovie.play();
}

//--------------------------------------------------------------
void ofApp::update(){
    testMovie.update();
}

//--------------------------------------------------------------
void ofApp::draw(){

	ofSetHexColor(0xFFFFFF);

    testMovie.draw(20,20);


    ofSetHexColor(0x000000);
	ofDrawBitmapString("press f to change",20,320);
    if(frameByframe) ofSetHexColor(0xCCCCCC);
    ofDrawBitmapString("mouse speed position",20,340);
    if(!frameByframe) ofSetHexColor(0xCCCCCC); else ofSetHexColor(0x000000);
    ofDrawBitmapString("keys <- -> frame by frame " ,190,340);
    ofSetHexColor(0x000000);

    ofDrawBitmapString("frame: " + ofToString(testMovie.getCurrentFrame()) + "/"+ofToString(testMovie.getTotalNumFrames()),20,380);
    ofDrawBitmapString("duration: " + ofToString(testMovie.getPosition()*testMovie.getDuration(),2) + "/"+ofToString(testMovie.getDuration(),2),20,400);
    ofDrawBitmapString("speed: " + ofToString(testMovie.getSpeed(),2),20,420);

    ofDrawBitmapString("width: " + ofToString(testMovie.getWidth(),2),20,440);
    ofDrawBitmapString("width: " + ofToString(testMovie.getHeight(),2),20,460);


    ofDrawBitmapString("fps: " + ofToString(ofGetFrameRate(),2),20,600);

    if(testMovie.getIsMovieDone()){
        ofSetHexColor(0xFF0000);
        ofDrawBitmapString("end of movie",20,440);
    }
}

//--------------------------------------------------------------
void ofApp::keyPressed  (int key){
    switch(key){
        case 'f':
            frameByframe=!frameByframe;
            testMovie.setPaused(frameByframe);
        break;
        case OF_KEY_LEFT:
            testMovie.previousFrame();
        break;
        case OF_KEY_RIGHT:
            testMovie.nextFrame();
        break;
        case '0':
            testMovie.firstFrame();
        break;
    }
}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){

}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){
	if(!frameByframe){
        testMovie.setPaused(true);
	}
}


//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){
	if(!frameByframe){
        testMovie.setPaused(false);
	}
}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){

}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){

}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}
